#ifndef __PG__BITREE_H__
#define __PG__BITREE_H__


/*
 * types : uint8, uint16, uint32, uint64
 */
typedef uint32  leveltype;

#define MAXCHILD (sizeof(leveltype) * 8)

typedef struct {
	int4		len;
	leveltype 	id[1];
} bitreenode;

#define CALCSIZE(nodelen) ( sizeof(leveltype)*(nodelen) + sizeof(int4) )
#define GETNODELEN(tn)    ( ( ((bitreenode*)tn)->len - sizeof(int4) ) / sizeof(leveltype) )
#define GETENTRY(vec,pos) ((bitreenode *) DatumGetPointer(((GISTENTRY *) VARDATA(vec))[(pos)].key))
#define ARRNELEMS(x)  ArrayGetNItems( ARR_NDIM(x), ARR_DIMS(x))
#define ARRPTR(x)  ( (bitreenode *) ARR_DATA_PTR(x) )
#define NEXTVAL( tnptr ) ( (bitreenode*)( (char*)tnptr + INTALIGN( VARSIZE(tnptr) ) ) )

#define NUMLEN	12
#define PRS_WAITNUM	1
#define PRS_INNUM	2
#define PRS_WAITDELIM	3
#define PRS_WAITLEVEL	4

#ifndef max
#define max(a,b)                ((a) >  (b) ? (a) : (b))
#endif
#ifndef min
#define min(a,b)                ((a) <= (b) ? (a) : (b))
#endif
#ifndef abs
#define abs(a)                  ((a) <  (0) ? -(a) : (a))
#endif

int cmp_binode(bitreenode *n1, bitreenode *n2);
bool inner_bi_isparent(bitreenode *parent, bitreenode *child);
bool inner_bitq_contain(bitreenode *node, bitreenode *mask, bool ignorezero );

/* debug */
char* printbinode( bitreenode *n );
#endif
